/*************************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.                  *
*  Site   : http://space.tin.it/computer/giparrel                                    *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                         *
*                                                                                    *
*  Revision:   1.1a  (April 3, 1998).                                                *
*                                                                                    *
*  Definition of JPFlatMenuGadget class.                                             *
*                                                                                    *
*  Read JPFLTMGA.TXT for use and license.                                            *
*                                                                                    *
*  Only for OWL 5.02 and 5.01 users.                                                 *
*  OWL and ObjectWindows are trademarks of Borland International.                    *
*                                                                                    *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF                *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO               *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A                    *
*  PARTICULAR PURPOSE.                                                               *
*************************************************************************************/
#if !defined(jpfltmga_h)
#define jpfltmga_h

#if !defined(OWL_TEXTGADG_H)
#include <owl/textgadg.h>
#endif
#if !defined(OWL_MENU_H)
# include <owl/menu.h>
#endif
#if !defined(OWL_GADGETWI_H)
#include <owl/gadgetwi.h>
#endif

//{{TTextGadget = JPFlatMenuGadget}}
class JPFlatMenuGadget : public TTextGadget {
  public:
    JPFlatMenuGadget(TMenu& menu, TWindow* window, int id = 0, TBorderStyle = Recessed, const char far* text = 0, TAlign = Left, uint numChars = 15, TFont* font = 0, bool Flat = true );
    virtual ~JPFlatMenuGadget();

  private:
    TPopupMenu*         GadgetPopupMenu;
    TWindow*            MenuTarget;
    TBorderStyle        DefaultBorderStyle;
    HWND                ParentWnd;
#if defined(BI_PLAT_WIN32)
    bool                TrackPopupMenuEx(uint flags, const TPoint& point, HWND wnd, const TRect* rect);
#endif

  protected:
    bool AutoTracking;
    enum FlatState {
    	fsNormal,
      fsUp,
      fsDown,
    };
    FlatState     CurrentFlatState;
	 void 			SetFlatState(FlatState state, bool update=true);
    FlatState     GetFlatState() const;

//{{JPFlatMenuGadgetVIRTUAL_BEGIN}}
  public:
    virtual void LButtonDown(uint modKeys, TPoint& point);
    virtual void MouseEnter(uint modKeys, TPoint& point);
    virtual void MouseLeave(uint modKeys, TPoint& point);
    virtual void PaintBorder(TDC& dc);
    virtual void SetTracking(bool enable);
    virtual void SetBorderStyle(TBorderStyle bs);
//{{JPFlatMenuGadgetVIRTUAL_END}}
};    //{{JPFlatMenuGadget}}

#endif
